# compound-callback-subtree
A subtree method that offers great flexibility and features to the developer.
<pre><code>npm i compound-callback-subtree</code></pre>

```javascript
const CompoundCallbackSubTree = require("compound-callback-subtree");
```
<h2>Class: <code>CompoundCallbackSubTree</code></h2>
<h3><code>new CompoundCallbackSubTree([options])</code></h3>
<ul>
	<details>
		<summary>
			<code>options</code> <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object">&lt;Object&gt;</a>
		</summary>
		<ul>
			<details>
				<summary>
					<code>dirStatsCb</code> <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Function">&lt;Function&gt;</a> Default: <code>(branchData, callback) => callback()</code> Optional
				</summary>
				<ul>
					<details>
						<summary>
							<code>branchData</code> <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object">&lt;Object&gt;</a> Parameter <b>required!</b>
						</summary>
						<ul>
							<details>
								<summary>
									<code>path</code> <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Data_structures#String_type">&lt;string&gt;</a>
								</summary>
								This is the full-path of the currently found directory.
							</details>
							<details>
								<summary>
									<code>stats</code> <a href="https://nodejs.org/dist/latest-v12.x/docs/api/fs.html#fs_class_fs_stats">&lt;fs.Stats&gt;</a>
								</summary>
								This is the <a href="https://nodejs.org/dist/latest-v12.x/docs/api/fs.html#fs_class_fs_stats">&lt;fs.Stats&gt;</a> of the currently found directory.
							</details>
							<details>
								<summary>
									<code>branch</code> <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object">&lt;Object&gt;</a>
								</summary>
								This is the branch of the currently found directory. All branches thogether fortake part of the end result tree that gets returend. Updating the branch affects the end result tree.
							</details>
						</ul>
                        Contains data of the current directory that is found.
					</details>
					<details>
						<summary>
							<code>callback</code> <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Function">&lt;Function&gt;</a></code> Parameter <b>required!</b>
						</summary>
						Compound callback subtree is asynchrononous. When initiating another asynchronous process do make sure to invoke callback or else this phase and the end result tree get blocked.
					</details>
				</ul>
                Trees are generated by recursively finding files and directories starting from the path. In order to know if the currently found thing is a file or directory <a href="https://nodejs.org/dist/latest-v12.x/docs/api/fs.html#fs_class_fs_stats">&lt;fs.Stats&gt;</a> must be generated. When there is a directory found dirStatsCb is invoked.
			</details>
			<details>
				<summary>
					<code>fileStatsCb</code> <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Function">&lt;Function&gt;</a> Default: <code>(data, callback) => callback()</code> Optional
				</summary>
				<ul>
					<details>
						<summary>
							<code>branchData</code> <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object">&lt;Object&gt;</a> Parameter <b>required!</b>
						</summary>
						<ul>
							<details>
								<summary>
									<code>path</code> <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Data_structures#String_type">&lt;string&gt;</a>
								</summary>
								This is the full-path of the currently found file.
							</details>
							<details>
								<summary>
									<code>stats</code> <a href="https://nodejs.org/dist/latest-v12.x/docs/api/fs.html#fs_class_fs_stats">&lt;fs.Stats&gt;</a>
								</summary>
								This is the <a href="https://nodejs.org/dist/latest-v12.x/docs/api/fs.html#fs_class_fs_stats">&lt;fs.Stats&gt;</a> of the currently found file. Interesting properties could be <code>birthtimeMs</code> or <code>size</code>.
							</details>
							<details>
								<summary>
									<code>branch</code> <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object">&lt;Object&gt;</a>
								</summary>
								This is the branch of the currently found file. All branches thogether take part of the end result tree that gets returend. Updating the branch affects the end result tree.
							</details>
						</ul>
                        Contains data of the current file that is found.
					</details>
					<details>
						<summary>
							<code>callback</code> <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Function">&lt;Function&gt;</a></code> Parameter <b>required!</b>
						</summary>
						Compound callback subtree is asynchrononous. When initiating another asynchronous process do make sure to invoke callback or else this phase and the end result tree get blocked.
				</ul>
                Trees are generated by recursively finding files and directories starting from the base-path. In order to know if the currently found thing is a file or directory <a href="https://nodejs.org/dist/latest-v12.x/docs/api/fs.html#fs_class_fs_stats">&lt;fs.Stats&gt;</a> must be generated. When there is a file found fileStatsCb is invoked.
			</details>
			<details>
				<summary>
					<code>subBranchCb</code> <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Function">&lt;Function&gt;</a> Default: <code>(data, nextBranch, blockBranch) => nextBranch()</code>
				</summary>
				<ul>
					<details>
						<summary>
							<code>branchData</code> <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object">&lt;Object&gt;</a> Parameter <b>required!</b>
						</summary>
						<ul>
							<details>
								<summary>
									<code>path</code> <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Data_structures#String_type">&lt;string&gt;</a>
								</summary>
								This is the full-path of the currently found file/directory.
							</details>
							<details>
								<summary>
									<code>dirpath</code> <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Data_structures#String_type">&lt;string&gt;</a>
								</summary>
								This is the full-path of the parent directory in which the current file/directory is found in.
							</details>
							<details>
								<summary>
									<code>file</code> <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Data_structures#String_type">&lt;string&gt;</a>
								</summary>
								This is the name of the currently found file/directory.
							</details>
							<details>
								<summary>
									<code>dirbranch</code> <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object">&lt;Object&gt;</a>
								</summary>
                                This is the branch of the parent directory. All branches thogether take part of the end result tree that gets returend. Updating the dirbranch affects the end result tree.
							</details>
						</ul>
					</details>
					<details>
						<summary>
							<code>proceed</code> <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Function">&lt;Function&gt;</a></code> Parameter <b>required!</b>
						</summary>
						<ul>
							<details>
								<summary>
									<code>nextBranch</code> <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object">&lt;Object&gt;</a> | <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Data_structures#Undefined_type">&lt;undefined&gt;</a>
								</summary>
								If the first argument nextBranch is passed to the proceed it becomes the next branch for that file/directory.
							</details>
						</ul>
						Compound callback subtree is asynchrononous. When initiating another asynchronous process do make sure to invoke proceed/block or else this phase and the end result tree get blocked. In case invoking proceed the process continues by calling <a href="https://nodejs.org/dist/latest-v16.x/docs/api/fs.html#fsstatpath-options-callback">fs.stat()</a> on the currently found file/directroy.
					</details>
					<details>
						<summary>
							<code>block</code> <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Function">&lt;Function&gt;</a></code> Parameter not required
						</summary>
						Compound callback subtree is asynchrononous. When initiating another asynchronous process do make sure to invoke proceed/block or else this phase and the end result tree get blocked. In case invoking block the process ends and this file/directory is not taking part in the en result tree and therefore block is usefull for ignoring.
					</details>
				</ul>
                Trees are generated by recursively finding files and directories starting from the base-path. After having found a directory, with <a href="https://nodejs.org/dist/latest-v16.x/docs/api/fs.html#fsreaddirpath-options-callback">fs.readdir()</a> each file gets passed through subBranchCb.
			</details>
		</ul>
		A substance formed from two or more elements chemically united in fixed proportions.
	</details>
</ul>
<h3><code>compoundCallbackSubTree.fromPath(path[,callback])</code></h3>
<ul>
    <details>
		<summary>
			<code>path</code> <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Data_structures#String_type">&lt;string&gt;</a>
		</summary>
		This is the starting path from where a tree is generated from.
	</details>
	<details>
		<summary>
			<code>callback</code> <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Function">&lt;Function&gt;</a> Default: <code>(err, tree) => console.log(tree)</code>
		</summary>
    	<ul>
			<details>
				<summary>
					<code>err</code> <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Data_structures#Null_type">&lt;Null&gt;</a> | <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Error">&lt;Error&gt;</a>
				</summary>
				The error returned from <a href="https://nodejs.org/dist/latest-v12.x/docs/api/fs.html#fs_fs_stat_path_options_callback">fs.stat()</a> or <a href="https://nodejs.org/dist/latest-v12.x/docs/api/fs.html#fs_fs_readdir_path_options_callback">fs.readdir()</a>.
			</details>
			<details>
				<summary>
					<code>tree</code> <a href="https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object">&lt;Object&gt;</a>
				</summary>
				This is the end result tree. Check out the the example below to see a tree.
			</details>
    	</ul>
        Compound callback subtree is asynchrononous.
	</details>
</ul>
Recursively generated a tree from a path. In order to increase efficiëncy, when invoking this method multiple times with the same path while the first process of that same path hasn't finished yet, the callback is appended to a callbacks array of the first process. When fromPath is invoked for different paths at the same time, the latter calls are queued untill the first process has finished, unless offcourse a separate instance of CompoundCallbackSubtree is processing the latter.
<h2>Example</h2>

```javascript
/*
node_modules (root)
|__test.js
|__compund-callback-subtree
|     |__ .git
|     |     |__ etc...
|     |__ MONKEY.json
|     |__ index.js
|     |__ package.json
|     |__ README.md
|__etc...
*/
const CompoundCallbackSubTree = require("compound-callback-subtree");
const statCallback = (branchData, callback) => callback(branchData.branch.path = branchData.path);
const subtree = new CompoundCallbackSubTree({
    dirStatCb: statCallback,
    fileStatCb: statCallback,
    subBranchCb: (branchData, proceed, block) => branchData.file.includes(".git") ? block() : proceed()
});

// posix no absolute path
subtree.fromPath("./");
{
    path: './',
    'index.d.ts': { path: 'index.d.ts' },
    'index.js': { path: 'index.js' },
    'MONKEY.json': { path: 'MONKEY.json' },
    'package.json': { path: 'package.json' },
    'README.md': { path: 'README.md' }
}

// win32 with absolute path (only if process.platform === "win32")
subtree.fromPath(path.resolve("./"));
{
  path: 'D:\\js\\node_modules\\compound-callback-subtree',
  'index.d.ts': {
    path: 'D:\\js\\node_modules\\compound-callback-subtree\\index.d.ts'
  },
  'index.js': { path: 'D:\\js\\node_modules\\compound-callback-subtree\\index.js' },
  'MONKEY.json': {
    path: 'D:\\js\\node_modules\\compound-callback-subtree\\MONKEY.json'
  },
  'package.json': {
    path: 'D:\\js\\node_modules\\compound-callback-subtree\\package.json'
  },
  'README.md': {
    path: 'D:\\js\\node_modules\\compound-callback-subtree\\README.md'
  }
}

// posix with absolute path
subtree.fromPath(path.posix.resolve("./"));
{
  path: '/js/node_modules/compound-callback-subtree',
  'index.js': { path: '/js/node_modules/compound-callback-subtree/index.js' },
  'MONKEY.json': { path: '/js/node_modules/compound-callback-subtree/MONKEY.json' },
  'package.json': { path: '/js/node_modules/compound-callback-subtree/package.json' },
  'README.md': { path: '/js/node_modules/compound-callback-subtree/README.md' }
}
subtree.fromPath("./");
```